diff --git a/src/xmpp/message.c b/src/xmpp/message.c
index f22b751ea..fd2b8e51d 100644
--- a/src/xmpp/message.c
+++ b/src/xmpp/message.c
@@ -922,6 +922,9 @@ _private_chat_handler(xmpp_stanza_t *const stanza)
     }
 #endif
 
+    message->timestamp = stanza_get_delay(stanza);
+    message->body = xmpp_message_get_body(stanza);
+
     if (!message->plain && !message->body) {
         log_error("Message received without body from: %s", message->jid->str);
         goto out;
@@ -929,9 +932,6 @@ _private_chat_handler(xmpp_stanza_t *const stanza)
         message->plain = strdup(message->body);
     }
 
-    message->timestamp = stanza_get_delay(stanza);
-    message->body = xmpp_message_get_body(stanza);
-
     if (message->timestamp) {
         sv_ev_delayed_private_message(message);
     } else {
